// 1. Global variables
var g_appObjArray = new Array(); //store all application info 
var g_isAllAppFrameLoaded = false; // Before dispatch events,make sure all applications are loaded
var g_timeoutID = null;
var GET_APPDATA_CONNECTION_TIMEOUT = "4000";
var GET_APPDATA_SUCCEED = 0;
var GET_APPDATA_TIMEOUT = 1;
var GET_APPDATA_FAIL = 2;
var g_objCoreGlobal = new CoreGlobal();
var g_objCallbackArray = new Array();
var appCnt = GetAppConfigItem("core", "AppCnt");
for(i=0; i<appCnt; i++)
{
	var appParam = GetAppConfigItem("core", "AppParam"+i)
	var expr = "g_appObjArray[" + i + "] = new AppInfo(" + appParam + ");";
	eval(expr);
}

// 2. CORE browser event handlers
document.OnAolSetConfig               = onAolSetConfig;
document.OnAolSAInit                  = sainit;
document.OnAolResize                  = onAolResize;
document.OnAolBeforeNavigate          = onAolBeforeNavigate;
document.OnAolNavigateComplete        = onAolNavigateComplete;
document.OnAolFrameNavigateComplete   = onAolFrameNavigateComplete;
document.OnAolFrameDocumentComplete   = onAolFrameDocumentComplete;
document.OnAolDocumentComplete        = onAolDocumentComplete;
document.CallbackGetAppData           = CallbackGetAppData;

// 3. Dynamic data download lib
function GetAppDataCallbackContext(AppName, DataName, cbFunc)
{
	this.idStr = AppName+"_"+DataName+"_"+cbFunc;
	this.appName = AppName;
	this.dataNameVersion = DataName+"Version";
	this.dataNameUrl = DataName+"URL";
	this.dataNameVal = DataName+"Val";
	this.dataVersion = GetAppConfigItem(AppName, this.dataNameVersion);
	this.CallbackToApp = cbFunc;
	this.hasCallback = false;
}

function GetAppData( appName, dataName, timeout, callBackFunc)
{
	var objCB = new GetAppDataCallbackContext(appName, dataName, callBackFunc);

	// Get user file system's merchant list version
	var fsDataVersion = GetCacheItem(appName, objCB.dataNameVersion, true);	
	
	// Get the latest data version from config XML.
	var configDataVersion = objCB.dataVersion;

	// if a newer version is available.
	if (fsDataVersion != configDataVersion)
	{	
		var dataURL = GetAppConfigItem(appName, objCB.dataNameUrl);
		dataURL+="?type="+g_objCoreGlobal.Browser+"_"+g_objCoreGlobal.Brand+"_"+g_objCoreGlobal.Locale;
		var idStr = objCB.idStr;
		g_objCallbackArray[idStr] = objCB;
		window.external.GetURLAsync(dataURL, GET_APPDATA_CONNECTION_TIMEOUT, GetBrowserId(), "CallbackGetAppData", idStr);
		window.setTimeout('GetAppDataTimeout(\''+idStr+'\')', timeout);
	}
	else
	{
		var dataVal = GetCacheItem(appName, objCB.dataNameVal, true);
		var callbackExp = "window.frames[appName]." + callBackFunc + "(GET_APPDATA_SUCCEED, dataVal)";
		eval(callbackExp);
	}
	   
	return;
}

// Dynamic data download lib wrapper
// If GetURLAsync() callback is longer than TIMEOUT, tells it's TIMEOUT	
function GetAppDataTimeout(idStr)
{
	var objCB = g_objCallbackArray[idStr];
	if ( objCB.hasCallback==false)
	{
		objCB.hasCallback = true;
		var callbackExp = "window.frames[objCB.appName]."+objCB.CallbackToApp+"(GET_APPDATA_TIMEOUT,'')";
		eval(callbackExp);
	}
}

// Dynamic data download lib wrapper
// GetURLAsync() callback	
function CallbackGetAppData(strData, idStr)
{	
	var objCB = g_objCallbackArray[idStr];
	// If timeout already, then do not call even has cb data 
	if (objCB.hasCallback)
		return;
	objCB.hasCallback = true;
	strData = strData.replace(/^\s*/, '');
	var isFromCache = false;
	if(strData.indexOf("RESULT=SUCCESS")==0)
		strData = strData.substr(14);
	else
	{
		strData = GetCacheItem(objCB.appName, objCB.dataNameVal, true);
		isFromCache = true;
	}
	// pass data to application
	var callbackExp = "window.frames[objCB.appName]."+objCB.CallbackToApp+"(GET_APPDATA_SUCCEED,strData)";	
	var bRet = eval(callbackExp);
	
	// Update user file system's merchant list version
	if (bRet && (!isFromCache))
	{
		SetCacheItem( objCB.appName, objCB.dataNameVersion, objCB.dataVersion, "$d9999", true);
		SetCacheItem( objCB.appName, objCB.dataNameVal, strData, "$d9999", true);				
	}
}

// 3. globals in core, pass to application when AppInit() is called
function CoreGlobal()
{
	this.WinX = 0;
	this.WinY = 0;
	this.ScreenName = "";
	this.IsGuestAccount = false;
	this.Browser = "ie";
	this.Brand = "AOL";
	this.Locale = "UK";
	this.GET_APPDATA_SUCCEED = GET_APPDATA_SUCCEED;
	this.GET_APPDATA_TIMEOUT = GET_APPDATA_TIMEOUT;
	this.GET_APPDATA_FAIL = GET_APPDATA_FAIL;
	this.SetCacheItem = SetCacheItem;
	this.GetCacheItem = GetCacheItem;
	this.GetBrowserId = GetBrowserId;
	this.GetURLAsync = GetURLAsync;
	this.GetURLSync = GetURLSync;
	this.GetAppConfigItem = GetAppConfigItem;
	this.GetAppData = GetAppData;
	this.ShowBar = ShowBar;
	this.GetTopDocument = GetTopDocument;
	this.GetAllDocuments = GetAllDocuments;	
	this.CallNative = CallNative;
	this.RegAsyncJSCallFunction = RegAsyncJSCallFunction;
	this.AsyncJavascriptCall = AsyncJavascriptCall;
}

function SetCacheItem(appName, itemName, itemVal, exp, bGlobal)
{
	window.external.SetCacheItem(appName, itemName, itemVal, exp, bGlobal);
}

function GetCacheItem(appName, itemName, bGlobal)
{
	return window.external.GetCacheItem(appName, itemName, bGlobal);
}

function GetBrowserId()
{
	return window.external.GetBrowserId();
}

function GetURLAsync(appName, url, timeout, browserId, callBack, idStr)
{
	var cbName = appName + "_" + callBack;
	var exp = "document."+cbName+"="+ "window.frames[appName]."+callBack;	
	eval(exp);
	window.external.GetURLAsync(url, timeout, browserId, cbName, idStr);
}

function GetURLSync(url, timeout)
{
	return window.external.GetURLSync(url, timeout);
}

function GetAppConfigItem(appName, confItem)
{
	return window.external.GetAppConfigItem(appName, confItem);
}

function GetTopDocument()
{
	return window.external.GetTopDocument();
}

function GetAllDocuments()
{
	return window.external.GetAllDocuments();
}

function ShowBar(bShow, height, url)
{
	if (!bShow)
		self.resizeTo( 100, 100 );
	else
	{
		self.resizeTo( 100, height + 100 );
		ui.location.href = url;
	}
}

function CallNative(dllName, funcName, paramsArray)
{
	// Unpack parameters: this function only accepts string type parameter 
	var exp = "window.external.CallNative(dllName, funcName";
	for (var i=0; i<paramsArray.length;i++)
		exp += ","+paramsArray[i];
	exp += ")";
	eval(exp);
}

function MakeTopAppJSName(appName, funcName)
{
	return appName + "_" + funcName;
}

function RegAsyncJSCallFunction(appName, funcName)
{	
	var exp = "document."+MakeTopAppJSName(appName,funcName)+"="+ "window.frames[appName]."+funcName;
	eval(exp);
}

function AsyncJavascriptCall(browserId, appName, funcName, paramsArray)
{
	return window.external.AsyncJavascriptCall(browserId, MakeTopAppJSName(appName, funcName), paramsArray);
}

// 4. Store each application specific information    
function AppInfo(appName, bExc, priority, bRunOrder)
{
	this.AppName = appName;
	this.IsAppIFrameLoaded = false;
	this.IsExclusive = bExc;
	this.Priority = priority;
	this.NExclRunBeforeExcl = bRunOrder; // true, run before exclusive category; false, run after exclusive category.</p>
	this.AppObj = null; //Will be assigned as the applications AppInit() return interface object
}

function isAllAppFrameLoaded()
{
	var bFlag = true;
	for (var i=0; i<g_appObjArray.length; i++)
	{
		if (g_appObjArray[i].IsAppIFrameLoaded == false)
		{
			bFlag = false;
			break;
		}
	}
	g_isAllAppFrameLoaded = bFlag;
	if(g_isAllAppFrameLoaded)
	{
		if (g_timeoutID) 
		clearTimeout(g_timeoutID);
		g_timeoutID = null;
		initApps();
	}
	else
	{
		g_timeoutID = setTimeout(isAllAppFrameLoaded, 100);
	}
}

function initApps()
{
	g_objCoreGlobal.Browser = GetAppConfigItem("core","browser");
	g_objCoreGlobal.Brand = GetAppConfigItem("core","brand");
	g_objCoreGlobal.Locale = GetAppConfigItem("core","locale");

	if (g_isAllAppFrameLoaded)
	{
		for (var i=0; i<g_appObjArray.length; i++)
		g_appObjArray[i].AppObj = window.frames[g_appObjArray[i].AppName].AppInit(g_objCoreGlobal);
	}
}
	
// Initialize app window until application is loaded
function AppLoaded(appName)
{
	for (var i=0; i<g_appObjArray.length; i++)
	{
		if (g_appObjArray[i].AppName == appName)
		{	
			g_appObjArray[i].IsAppIFrameLoaded = true;
			break;
		}
	}
}
	
// Calls AppExit() if application's iframe onunload() is triggered
function AppUnloaded(appName)
{
	for (var i=0; i<g_appObjArray.length; i++)
	{
		if (g_appObjArray[i].AppName == appName)
		{
			window.frames[appName].AppExit();
			break;
		}
	}
}

// If empty URL or about:blank, does NOT dispatch
function shouldDispatch(url)
{
	if (url=="" || (url.indexOf("about:blank")==0))
		return false;
		
	return true;
}

// browser event handlers
function sainit()
{	
	isAllAppFrameLoaded();
}

function onAolSetConfig(id, value)
{
	if (id == 1)
		g_objCoreGlobal.ScreenName = value;
	if (id == 2)
		g_objCoreGlobal.IsGuestAccount = value;		
}

function onAolResize(cx, cy)
{
	g_objCoreGlobal.WinX = cx;
	g_objCoreGlobal.WinY = cy;
}

function onAolDocumentComplete(newURL)
{
	if (shouldDispatch(newURL))
		LoopApps("onAolDocumentComplete", newURL);
}

function onAolFrameDocumentComplete(newURL)
{
	if (shouldDispatch(newURL))
		LoopApps("onAolFrameDocumentComplete", newURL);
}

function onAolBeforeNavigate(newURL)
{
	if (shouldDispatch(newURL))
		LoopApps("onAolBeforeNavigate", newURL);
}

function onAolFrameNavigateComplete(newURL)
{
	if (shouldDispatch(newURL))
		LoopApps("onAolFrameNavigateComplete", newURL);
}

function onAolNavigateComplete(newURL)
{
	if (shouldDispatch(newURL))
		LoopApps("onAolNavigateComplete", newURL);
}

function LoopApps(eventName,newURL)
{
	if ( !g_isAllAppFrameLoaded)
	{
		var cb = 'LoopApps(\''+ eventName + '\',\'' + newURL+ '\')';
		window.setTimeout(cb,150);
		return;
	}
	try
	{
		//1. Run Non-Exclusive application that require run before exclusive category
		for (var i=0; i<g_appObjArray.length; i++)
		{
			// Non_Exclusive and run before exclusive
			if ((g_appObjArray[i].IsExclusive == false) && (g_appObjArray[i].NExclRunBeforeExcl == true))
			{
				// Is there an event handler?
				var tmp = "g_appObjArray[i].AppObj."+eventName;
				if ((eval(tmp) != null) && (typeof(eval(tmp)) != "undefined"))
				{
					// Dispatch
					var exp = 'window.frames[g_appObjArray[i].AppName].'+eventName+'(newURL)';
					eval(exp);
				}
			}
		}
		// 2. From the highest priority application to the lowest priority one in exclusive category
		//    ask if the current application wants to consume this event
		//    if Yes, call current application.OnDocComplete(). if No, CONTINUE.
		for (var i=0; i<g_appObjArray.length; i++)
		{
			// Exclusive
			if ( (g_appObjArray[i].IsExclusive == true))
			{
				// Is there an event handler?
				var tmp = "g_appObjArray[i].AppObj."+eventName;
				if ((eval(tmp) != null) && (typeof(eval(tmp)) != "undefined"))
				{
					// Dispatch
					var exp = 'window.frames[g_appObjArray[i].AppName].'+eventName+'(newURL)';
					eval(exp);
					break;
				}
			}
		}
		//3. Run Non-Exclusive categorys group that requires run after exclusive category
		for (var i=0; i<g_appObjArray.length; i++)
		{
			// Non_Exclusive and run before exclusive
			if ( (g_appObjArray[i].IsExclusive == false) && (g_appObjArray[i].NExclRunBeforeExcl == false))
			{
				// Is there an event handler?
				var tmp = "g_appObjArray[i].AppObj."+eventName;
				if ((eval(tmp) != null) && (typeof(eval(tmp)) != "undefined"))
				{
					// Dispatch
					var exp = 'window.frames[g_appObjArray[i].AppName].'+eventName+'(newURL)';
					eval(exp);
				}
			}
		}
	}
	catch(e){};		
}

// Suppress all JS errors
window.onerror = StopJSError;
function StopJSError()
{
	return true;
}
