function QcffLists(MD,SD,resHosts)
{
	//no billing or third party domains associated with these sites
	MD["BANANAREPUBLIC.COM"] = true;
	MD["COLLECTIBLESTODAY.COM"] = true;
	MD["ELUXURY.COM"] = true;
	MD["OLDNAVY.COM"] = false;

	//following 4 sites added for testing Incomplete Header Code fix
	//they have no billing or third party domains
	MD["FRANKLINMINT.COM"] = false;
	MD["REI.COM"] = true;
	
	//bug fix sites
	MD["AVON.COM"] = true; // Bug Fix AND No billing or 3rd party domains
	MD["NATIONALGEOGRAPHIC.COM"] = false;
	
	//these have third party and billing domains
	MD["KBTOYS.COM"] = false; // Has Shopping Domain KBKIDS.COM
	MD["KMART.COM"] = new MerchantProp( new Array("KMARTCORP.COM"), false);
	MD["RHINO.COM"] = new MerchantProp( new Array("RHINO-EXPRESSCHECKOUT.COM","TIMEWARNERORDERCENTER.COM"), true);
	MD["YLIGHTING.COM"] = new MerchantProp( new Array("YAHOO.COM"), false);

	//sites that are exceptional for checkout form detection
	//but rules do not contain OH profile info
	MD["AMATTEROFFAX.COM"] = true;
	MD["CRAZYTREE.COM"] = true;
	MD["DRUGSTORE.COM"] = true;
	MD["NORDSTROM.COM"] = true;

	//broken form mapping
	MD["CARLTONCARDS.COM"] = false;

	//aliases to a site grouped here
	SD["BLUELIGHT.COM"] = "KMART.COM";

	SD["RHINOHANDMADE.COM"] = "RHINO.COM";
	SD["RHINOVIDEO.COM"] = "RHINO.COM";
	SD["DEAD.NET"] = "RHINO.COM";

	SD["KBKIDS.COM"] = "KBTOYS.COM";
	
	resHosts[0] = "edit.secure.yahoo.com";
}
